#define HAUTEUR_MENU 16
#define LARGEUR_MENU 240
#define MAX_OBJETS 10

void Clic(int leMenu, int no_objet);
void LitTexte(char *fichier);
int menuDoitResterOuvert, clic_gauche;
ECRAN ecrCour;

class CMenu		{
private:
	ECRAN *Ecran;
	OBJET *objEcran;
	char *Chaines[MAX_OBJETS];
	int positions[MAX_OBJETS], tailles[MAX_OBJETS], lumiere[MAX_OBJETS], *sousMenus[MAX_OBJETS], transCadre[MAX_OBJETS];
	int nObj, pos_base;
	int x_souris, y_souris, position_menu;

public:
	CMenu()		{
		Ecran=CreeEcran(LARGEUR_MENU,HAUTEUR_MENU);
		objEcran=EcranVersObjet(Ecran);
		nObj=0;
		pos_base=0;
		position_menu=HAUTEUR_MENU;
		x_souris=0xffffffff, y_souris=0xffffffff;
	}
	~CMenu()		{
		DetruitEcran(Ecran);
	}

	void Init()		{
		nObj=0;
		pos_base=0;
	}

	void DessObjet(int no_objet)		{
		//Objet point -> surbrillance
		if (*sousMenus[no_objet] || (x_souris>=positions[no_objet] && x_souris<positions[no_objet]+tailles[no_objet] && y_souris<HAUTEUR_MENU))		{
			if (lumiere[no_objet]<127)
				lumiere[no_objet]+=8;
			if (clic_gauche)
				Clic(0,no_objet);
		}
		else if (lumiere[no_objet]>0)
			lumiere[no_objet]-=8;

		//Objet slectionn -> cadre transparent au-dessus de lui
		if (*sousMenus[no_objet])	{
			if (transCadre[no_objet]<128)
				transCadre[no_objet]+=8;
		}
		else if (transCadre[no_objet]>0)
			transCadre[no_objet]-=8;

		if (!skip)		{
			//Le cadre
			FxRect(positions[no_objet],2,tailles[no_objet],12,BLANC,FX_TRANS,transCadre[no_objet]);
			FxCadre(positions[no_objet]+1,3,tailles[no_objet]-2,10,RGB(0,255,0),FX_TRANS,transCadre[no_objet]);
			//Le texte
			CouleurTexte(RGB(255,128+lumiere[no_objet],128+lumiere[no_objet]));
			DessTexte(positions[no_objet],1,Chaines[no_objet]);
		}
	}

	void Gere()		{
		int i,j;
		PositionSouris(&x_souris,&y_souris);
		if (menuDoitResterOuvert || (y_souris>=0 && y_souris<HAUTEUR_MENU))		{
			if (position_menu>0)
				position_menu--;
		}
		else	{
			if (position_menu<HAUTEUR_MENU)
				position_menu++;
		}
		if (position_menu>=HAUTEUR_MENU)		{
//			Sleep(50);
//			ReinitTimer();
			return;
		}

		if (!skip)		{
			ChoisitEcran(Ecran);
			for (i=0;i<HAUTEUR_MENU;i++)		{
				j=256*i/HAUTEUR_MENU;
				FxCadre(0,i,LARGEUR_MENU,1,RGB(0,0,j));
			}

			ChangeFonte("Verdana",12);
			FondTexte(TRANSPARENT);
		}

		for (i=0;i<nObj;i++)
			DessObjet(i);

		if (!skip)		{
			ChoisitEcran(&ecrCour);
			FxObjet(objEcran,0,0,FX_TRANS,256-256*position_menu/HAUTEUR_MENU);
		}
	}

	void AjObjet(char *texte, int largeur, int *sousMenu)		{
		Chaines[nObj]=texte;
		tailles[nObj]=largeur;
		positions[nObj]=pos_base;
		lumiere[nObj]=127;
		sousMenus[nObj]=sousMenu;
		transCadre[nObj]=0;
		pos_base+=largeur+5;
		nObj++;
	}

};

class CSousMenu		{
private:
	ECRAN *Ecran;
	OBJET *objEcran;
	char *Chaines[MAX_OBJETS];
	int positions[MAX_OBJETS], lumiere[MAX_OBJETS], Actif[MAX_OBJETS];
	int nObj, pos_base;
	int x_souris, y_souris;
	int transparence;

public:
	int offset_x, offset_y, actif;
	int LARG_SOUSMENU, HAUT_SOUSMENU;

	CSousMenu()		{
		actif=0;
		transparence=0;
		Ecran=NULL;
		objEcran=NULL;
	}

	void Init()		{
		Ecran=CreeEcran(LARG_SOUSMENU,HAUT_SOUSMENU);
		objEcran=EcranVersObjet(Ecran);
		nObj=0;
		pos_base=0;
		x_souris=0xffffffff, y_souris=0xffffffff;
		actif=0;
	}

	~CSousMenu()		{
		if (Ecran)
			DetruitEcran(Ecran);
	}

	void DessObjet(int no_objet)		{
		if (x_souris>=0 && x_souris<LARG_SOUSMENU && y_souris>=positions[no_objet]-1 && y_souris<positions[no_objet]+11)		{
			if (lumiere[no_objet]<127)
				lumiere[no_objet]+=8;
			if (clic_gauche && Actif[no_objet])
				Clic(actif,no_objet);
		}
		else if (lumiere[no_objet]>0)
			lumiere[no_objet]-=8;

		if (!skip)		{
			if (Actif[no_objet])
				FxCadre(1,positions[no_objet]+1,LARG_SOUSMENU-2,12,JAUNE,FX_TRANS,lumiere[no_objet]);
//			CouleurTexte(RGB(128+lumiere[no_objet],255,128+lumiere[no_objet]));
			if (Actif[no_objet])
				CouleurTexte(BLANC);
			else
				CouleurTexte(RGB(128,128,128));
			DessTexte(4,positions[no_objet],Chaines[no_objet]);
		}
	}

	void Gere()		{
		int i,j;
		if (!actif)		{
			if (transparence>0)
				transparence-=16;
			else	{
				return;
			}
		}
		else	{
			if (transparence<256)
				transparence+=16;
		}

		PositionSouris(&x_souris,&y_souris);
		x_souris-=offset_x, y_souris-=offset_y+2;
		if (!(x_souris>=0 && x_souris<LARG_SOUSMENU && y_souris>=0 && y_souris<HAUT_SOUSMENU))		{
			if (clic_gauche)		{
				actif=0;
				Clic(actif,-1);
			}
		}

		if (!skip)		{
			ChoisitEcran(Ecran);
			for (i=0;i<HAUT_SOUSMENU;i++)		{
				j=128-96*i/HAUT_SOUSMENU;
				FxCadre(0,i,LARG_SOUSMENU,1,RGB(j,0,0));
			}
	//		Cadre(0,0,LARG_SOUSMENU,HAUT_SOUSMENU,RGB(0,0,128));
			ChangeFonte("Verdana",12);
			FondTexte(TRANSPARENT);
		}

		for (i=0;i<nObj;i++)
			DessObjet(i);

		if (!skip)	{
			ChoisitEcran(&ecrCour);
			FxObjet(objEcran,offset_x,offset_y,FX_TRANS,transparence);
		}
	}

	void AjObjet(char *texte, char actif=1)		{
		Chaines[nObj]=texte;
		positions[nObj]=pos_base;
		lumiere[nObj]=0;
		Actif[nObj]=actif;
		pos_base+=12;
		nObj++;
	}
};


CSousMenu SousMenuFichier, SousMenuConvert, SousMenuMachine;
CMenu Menu;
int SignalMenu, SignalObjet;

void Clic(int leMenu, int no_objet)		{
	if (no_objet==-1)		{
		menuDoitResterOuvert=0;
	}
	else if (leMenu==0 && no_objet==0)		{
		SousMenuFichier.actif=1;
		SousMenuConvert.actif=0;
		SousMenuMachine.actif=0;
		menuDoitResterOuvert=1;
	}
	else if (leMenu==0 && no_objet==1)		{
		SousMenuFichier.actif=0;
		SousMenuConvert.actif=2;
		SousMenuMachine.actif=0;
		menuDoitResterOuvert=1;
	}
	else if (leMenu==0 && no_objet==2)		{
		SousMenuFichier.actif=0;
		SousMenuConvert.actif=0;
		SousMenuMachine.actif=3;
		menuDoitResterOuvert=1;
	}
	else	{
		menuDoitResterOuvert=0;
		SignalMenu=leMenu;
		SignalObjet=no_objet;
	}
	if (leMenu==1)		{
		SousMenuFichier.actif=0;
	}
	else if (leMenu==2)		{
		SousMenuConvert.actif=0;
	}
	else if (leMenu==3)		{
		SousMenuMachine.actif=0;
	}
}

